Hello, and welcome to FusionRedux Framework!

These are our new guidelines for support.  Please read them thoroughly before submitting an issue on our issue tracker (or if you were directed her, modify your ticket with the required information).

First, and most importantly, we need to know if you are a developer using FusionRedux in their project, or if you are using a theme/plugin that uses FusionRedux.  FusionRedux is a tool for developers to include an options panel in their project.  Consequently, we do not offer support for folks who have purchased a theme or plugin that uses FusionRedux.  The responsibility of support for themes and plugins falls upon it's author.  We realize that some authors have included support links for FusionRedux in their projects, when they should not have.  We do apologize for that confusion and are taking steps to remedy this confusion.  If you have purchased a theme or plugin that utilizes FusionRedux, please contact the author for support.  If the author is unavailable for support or has discontinued support, please refer to this article: [Support Defined](https://docs.fusionreduxframework.com/core/support-defined/).

If you are a developer, using FusionRedux Framework in your project, PLEASE check to see if you are using the latest version of FusionRedux by checking this repository.  If you plan to reporting an issue with any version BUT the latest version, we are going to ask you to upgrade to the latest code base anyway to see if your issue persists.  Please save yourself and us some time by taking this simple step first.  Thanks!

We designed our issue tracker to help identify and correct issues within FusionRedux Framework.  If you believe you have discovered an issue, or something is not working as it should, then submitting an issue is appropriate.  However, if you are looking for a custom solution involving FusionRedux, or require assistance with original code unrelated to the FusionRedux core itself, then this type of support falls under Premium support.  We are not PHP/JavaScript tutors, or a version of Stack Overflow, or have the time and resources to debug your code.  For Premium support options, please visit this page: [Premium Support](https://fusionreduxframework.com/extension/premium-support/).  Our cost is $100.00 per hour.  If you require a more tailored quote, please contact support@fusionreduxframework.com.

We handle all support for FusionRedux Framework via our issue tracker.  Email support is available only for those who have purchased Premium Support, or in instances where we have requested contact via EMail.

For FusionRedux Extensions:  All pre-sale and support for premium extensions need to be posted to the [FusionRedux Extensions Issue Tracker] (https://github.com/fusionreduxframework/fusionredux-extensions).  Please do not post them to this issue tracker.

You MUST be using FusionRedux in dev mode when submitting an issue to us.  If you are not, or have circumvented our dev mode protocol, you are on your own.  There could be information in your issue that requires dev move active. (Compressed Javascript, for example.  We are unable to diagnose issues with compressed Javascript and why dev mode needs to be enabled.)

Because it is sometimes difficult to get all the necessary information for a support issue,we have designed the Support URL protocol, in which we are able to gather all the required data via one URL.  It will be necessary for you to post one in your issue.  Please refer to this article for instructions on generating a support URL: [Generating a Support URL] (https://docs.fusionreduxframework.com/core/generating-a-support-hash/).  This is *required*.  We will not be able to offer support without one.  We appreciate the understanding.

If an error or notice appears on your screen, please cut and paste it into your issue.  PLEASE, do not say you 'got an error' without telling us what the error or notice is.

Sometimes, an issue may be tied to JavaScript.  To make this determination, you will need to check the JavaScript console.  To do this, ensure your web browser is the topmost window.  On your keyboard, press CTRL+SHIFT+I.  The JavaScript console will open.  If there are notices or errors there, please cut and paste them into your issue.  We would prefer a cut and paste, since it will include all pertinent information.  Also, FusionRedux dev mode must be enabled so an accurate line number may be reported.

It would also be hugely helpful to us if you are able to indicate any steps taken up until the issue occurred.  We may need to be able to recreate your issue on our end, and having this information would help with that.  Simply stating something 'doesn't work' isn't helpful, and tells us nothing.  PLEASE, be as specific as possible.

- Team FusionRedux
